Subject: Re: [linux-next][PATCH] revert headers_check fix: ia64, fpu.h

From: Ingo Molnar <[email-masked]>
Date: Fri, 6 Feb 2009 18:14:00 +0100

* Russell King - ARM Linux <[email-masked]> wrote:

> On Fri, Feb 06, 2009 at 05:33:14PM +0100, Ingo Molnar wrote:
> > 
> > * Russell King - ARM Linux <[email-masked]> wrote:
> > 
> > > On Fri, Feb 06, 2009 at 05:12:29PM +0100, Ingo Molnar wrote:
> > > > 
> > > > * Russell King - ARM Linux <[email-masked]> wrote:
> > > > 
> > > > > > We cannot see any downside of this patch.
> > > > > > 
> > > > > > But we can see upside of this patch is:
> > > > > > 1. No need to protect linux/types.h with #ifndef __ASSEMBLY__ in many
> > > > > > files
> > > > > > 2. So we trying to replace multiple #ifndef __ASSEMBLY__ with one.
> > > > > 
> > > > > The point is:
> > > > > 
> > > > > 1. If the parent include needs to include linux/types.h to get at C
> > > > >    types _and_ the include file needs to also be included by assembly
> > > > >    code, it itself needs to have #ifndef __ASSEMBLY__ to protect those
> > > > >    uses from the assembly code.
> > > > > 
> > > > >    In that case, the linux/types.h include should be contained within
> > > > >    the #ifndef __ASSEMBLY__ .. #endif block along with all C only
> > > > >    parts of the header file.
> > > > 
> > > > That makes the code much less clean: putting #include's in the middle of a 
> > > > header is poor style and leads to people failing to consider dependencies. 
> > > > We generally put them to the header portion.
> > > > 
> > > > Putting an #include line in the middle of a header file is a receipe for a 
> > > > dependency hell (it can easily fall inside #ifdefs, can be overlooked, 
> > > > etc.), so it's _strongly_ discouraged (at least on arch/x86).
> > > 
> > > Put them at the top then with an additional ifndef.
> > 
> > So you advocate 40 stupid pairs of #ifdefs spread out, instead of a 
> > _single_, obvious #ifdef in a commonly used header?
> 
> As I see it, if you want all your style points to be adhered to, then yes.
> And I do believe it to be a valid solution.
> 
> Personally, I'd put them nearer the C code.
> 
> That's precisely what I do with the ARM include files.  Never been a
> problem.

I take this that you kind of agree that that removing ugly #ifdefs spread 
out is an upside. You failed to point out any downsides - you just seem to 
claim that you can live without the upsides. That is fine.

	Ingo